alias dme dialog $+(-,$iif($dialog(dme.setup),v,m)) dme.setup dme.setup
alias _dme.version return 0.5
alias _dme.get {
  if ($bg.strip($strip($1-,o)) !=== $strip($1-,o)) return $ifmatch
  return $1-
}
alias -l bg.strip {
  if ($hget(dme,bg.strip) == 1) {
    var %r = /([0-9]{1,2})(,[0-9]{1,2})/g
    !.echo -q $regsub($1-,%r,\1,%r)
    return %r
  }
  return $1-
}
alias -l _dme.ddcolor {
  var %r = /(?<=\x03\d\d,|\x03\d,|\x03)(\d)(?!\d)/g
  !.echo -q $regsub($1,%r,0\1,%r)
  return %r
}
menu menubar {
  MSG Extensions:dme
}
on ^*:text:*:#: {
  if (!$_dnc.version) {
    if ($bg.strip($strip($1-,o)) !=== $strip($1-,o)) {
      echo $color(normal) -mlbfti2 $chan $+(<,$nick($chan,$nick).color,$nick,>) $ifmatch
      haltdef
    }
  }
}
on ^*:text:*:?: {
  if ($bg.strip($strip($1-,o)) !=== $strip($1-,o)) {
    if ($query($nick)) {
      echo $color(normal) -mti2 $nick $+(<,$nick,>) $bg.strip($strip($1-,o))
      haltdef
    }
    else {
      if ($window(Message Window)) { echo $color(normal) -dmti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
      elseif ($gettok($readini($mircini,options,n0),22,44)) { dqwindow show | echo $color(normal) -dmti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
      elseif ($cid == $activecid) && (@* !iswm $active) && ($gettok($readini($mircini,options,n4),5,44)) { echo $color(normal) -amti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
      else { echo $color(normal) -smti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
    }
  }
}
on ^*:action:*:#:{
  if ($bg.strip($strip($1-,o)) !=== $strip($1-,o)) {
    echo $color(action) -mlbfti2 $chan * $nick $bg.strip($strip($1-,o))
    haltdef
  }
}
on ^*:action:*:?: {
  if ($bg.strip($strip($1-,o)) !=== $strip($1-,o)) {
    if ($query($nick)) {
      echo $color(action) -mti2 $nick $+(<,$nick,>) $bg.strip($strip($1-,o))
      haltdef
    }
    else {
      if ($window(Message Window)) { echo $color(action) -dmti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
      elseif ($gettok($readini($mircini,options,n0),22,44)) { dqwindow show | echo $color(action) -dmti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
      elseif ($cid == $activecid) && (@* !iswm $active) && ($gettok($readini($mircini,options,n4),5,44)) { echo $color(action) -amti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
      else { echo $color(action) -smti2 $+(*,$nick,*) $bg.strip($strip($1-,o)) | haltdef }
    }
  }
}
on *:start: {
  if (($version < 6.03) || ($bits != 32)) {
    echo $color(no) -s *** Error: defcon Message Extensions requires mIRC 32 Bit v6.03 and above.
    unload -rs $nopath($script)
  }
  else {
    if ($hget(dme) == dme) hfree dme
    hmake dme 2
    if ($isfile($+(",$shortfn($scriptdir),dme.hsh,"))) hload dme $+(",$shortfn($scriptdir),dme.hsh,")
    if ($hget(dme,timestampfmt) != $null) .timestamp -f $ifmatch
  }
}
on *:unload: {
  echo $color(i) -es Unload Defcon Message Extensions v $+ $_dme.version
  if ($dialog(dme.setup)) {
    echo $color(i) -s Close Dialog
    dialog -x dme.setup
  }
  if ($hget(dme)) {
    echo $color(i) -s Free existing hash table.
    hfree dme
  }
  echo $color(i) -es Finished Unloading Defcon Message Extensions v $+ $_dme.version
}
dialog -l dme.setup {
  title Messages Extensions [/dme]
  size -1 -1 130 50
  option dbu
  text "Timestamp format:" , 1, 5 7 47 8
  edit , 2, 55 5 50 10, autohs limit 100
  check "Strip background color from incoming messages", 3, 5 20 125 10
  text "Version: 0.5", 4, 5 37 29 8, disable
  button &OK, 5, 50 35 37 12, default ok
  button "&Cancel", 6, 90 35 37 12, cancel
}
on *:dialog:dme.setup:init:0: {
  did -a dme.setup 2 $timestampfmt
  if ($hget(dme,bg.strip) == 1) did -c dme.setup 3
}
on *:dialog:dme.setup:sclick:5: {
  did -o dme.setup 2 1 $_dme.ddcolor($did(2).text)
  hadd -m dme bg.strip $did(dme.setup,3).state
  hadd dme timestampfmt $did(dme.setup,2)
  .timestamp -f $did(dme.setup,2)
  hsave -o dme $+(",$shortfn($scriptdir),dme.hsh,")
}
